%% Convergence Rate Analysis

% this is a rather clunky script making the maximum error plots. It uses
% the barylagrangeinterp function

close all
format long g

% number of interpolation points
N = 0:10:250;
u = -1:0.001:1;
max_err1=[];


for n = 1:length(N)
    
    x = cos(pi*(0:N(n))/N(n));
    y = exp(x)./cos(x);
    v = barylagrangeinterp(x,y,u);
    y1 = exp(u)./cos(u);
    err = abs(v-y1);
    max_err1 = [max_err1 max(err)];
end

max_err2=[];

for n = 1:length(N)
    
    x = cos(pi*(0:N(n))/N(n));
    y = 1./(1+12*x.^2);
    v = barylagrangeinterp(x,y,u);
    y1 = 1./(1+12*u.^2);
    err = abs(v-y1);
    max_err2 = [max_err2 max(err)];
end

max_err5=[];

for n = 1:length(N)
    
    x = cos(pi*(0:N(n))/N(n));
    y = 1./(1+50*x.^2);
    v = barylagrangeinterp(x,y,u);
    y1 = 1./(1+50*u.^2);
    err = abs(v-y1);
    max_err5 = [max_err5 max(err)];
end

max_err3=[];

for n = 1:length(N)
    
    x = cos(pi*(0:N(n))/N(n));
    y = abs(x);
    v = barylagrangeinterp(x,y,u);
    y1 = abs(u);
    err = abs(v-y1);
    max_err3 = [max_err3 max(err)];
end

max_err4=[];

for n = 1:length(N)
    
    x = cos(pi*(0:N(n))/N(n));
    y = tan(x);
    v = barylagrangeinterp(x,y,u);
    y1 = tan(u);
    err = abs(v-y1);
    max_err4 = [max_err4 max(err)];
end




figure(1)
semilogy(N,max_err1,N,max_err2,N,max_err5,N,max_err3,N,max_err4,'LineWidth',2)
title('Maximum error of interpolation, chebyshev points','FontWeight','bold','FontSize',14)
xlabel('N','FontWeight','bold')
ylabel('Max Error','FontWeight','bold')
legend('exp(x)/cos(x)','1/(1+12*x^2)','1/(1+50*x^2)','abs(x)','tan(x)')
set(gca,'box','off','FontSize',12,'FontWeight','bold')
set(legend, 'FontSize',13,'Location','East')


