%% More exploration about the convergence of abs(x)!

% Here I used Trefethen's barycentric lagrange interpolation code to
% explore some aspects about |x|.

% Pretty clunky code, more focused on observing behavior of interpolation

format long g

loc =[];
max_err =[];
mean_err = [];
r=floor(linspace(10,5000,20));

    for n = floor(linspace(10,5000,20))
    x = cos(pi*(0:n)'/n);
    f = abs(x);
    c = [1/2; ones(n-1,1); 1/2].*(-1).^((0:n)');
    xx = linspace(-1,1,n+1)';
    numer = zeros(size(xx));
    denom = zeros(size(xx));
    exact = zeros(size(xx));
    for j = 1:n
        xdiff = xx-x(j);
        temp = c(j)./xdiff;
        numer = numer + temp*f(j);
        denom = denom + temp;
        exact(xdiff==0) = 1;
    end
    
    ff = numer./denom;
    jj=find(exact);
    ff(jj)=f(exact(jj));
    
        
    
    
    merr = norm(f-ff,inf); 
    max_err = [max_err merr];

%   Trying to find the location of the max err:

  err = abs(f-ff);
  loc_merr = find(err==merr);
  loc = [loc loc_merr];
  meanerr = mean(err);
  mean_err = [mean_err meanerr];
  
  
    if n == r(2)
        figure(1)
        plot(xx,ff,'-')
        hold on
        plot(xx(loc_merr),ff(loc_merr),'r*')
        title(['location of maximum error, n: ' num2str(n)]) 
    end
   
     if n == r(12)
        figure(2)
        plot(xx,ff,'-')
        hold on
        plot(xx(loc_merr),ff(loc_merr),'r*')
        title(['location of maximum error, n: ' num2str(n)])
     end
    
    end
 
    
    figure(3)
    loglog(r,max_err)
    title('Maximum error of interpolation of abs(x)')
    
    figure(4)
    locper = (loc./r);     
    plot(r,locper) 
    title('location of max err relative to the number of interpolation points')
    
    figure(5)
    loglog(r,mean_err)
    
    
    
    




